/*	$Kolabore: darwin.h,v 1.3 2006/10/03 09:34:31 maxx Exp $	*/
/*
 * Copyright (c) 2006 Timothy Goh <timgoh0-at-gmail-dot-com>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __DARWIN_H__
#define __DARWIN_H__

#include <mach/host_info.h>

#include "common.h"

using namespace std;

class XSI : public XSICommon {
public:
	XSI(void);
	~XSI(void);

	int		tryOpenPrivilegedDevices(void);

private:
	void		collectSysInfo(void);
	void		updateStats(void);
	
	string		getSysctlString(int, int, int, unsigned int,
					bool, const char *);

	void		readSystemArch(void);
	void		readSystemModel(void);
	void		readSystemCPUFreq(void);
	void		readSystemVendor(void);
	void		readSystemNumCPUs(void);
	void		readSystemOSInfo(void);

	void		readNetIfInfo(XSI_NetIfStat &, struct ifaddrs *);
	void		readNetIfAddrs(XSI_NetIfStat &, struct ifaddrs *, string);

	void		updateCPUStats(void);
	void		updateVMStats(void);
	void		updateFSStats(void);
	void		updateOSUptime(void);
	void		updateLoadAvg(void);
	void		updateNetStats(void);

	int		num_cpu;
	int64_t       **last_cp_time, **cur_cp_time;


	host_cpu_load_info_data_t cur, last;


};

#endif /* __DARWIN_H__ */
