/*	$Kolabore: network.cpp,v 1.9 2006/10/29 18:42:41 maxx Exp $	*/
/*
 * Copyright (c) 2006 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#include "typesetup.h"

extern "C" {
#include <sys/param.h>
#ifdef HAVE_LINUX_PARAM_H
#  include <linux/param.h>
#endif

#ifdef HAVE_ERR_H
#  include <err.h>
#endif
#ifndef MAXHOSTNAMELEN
#  include <netdb.h>
#  ifndef MAXHOSTNAMELEN
#    define MAXHOSTNAMELEN 256
#  endif
#endif
#ifdef HAVE_STDINT_H
#  include <stdint.h>
#endif
#include <unistd.h>
}

#include <string>
#include <vector>

#include "network.h"
#include "compat/xsicompat.h"

using namespace std;

XSI_Network::XSI_Network(void)
{
	char buf[MAXHOSTNAMELEN];

	if (gethostname(buf, sizeof(buf)) == -1)
		err(1, "%s: gethostname", __func__);
	hostname = buf;
}

void
XSI_Network::setNetIfStats(vector<XSI_NetIfStat> nstats)
{
	net_stats = nstats;
}

void
XSI_Network::setDefaultRoutes(vector<struct default_route> routes)
{
	default_routes = routes;
}

const char *
XSI_Network::getHostName(void)
{
	return (hostname.c_str());
}

vector<XSI_NetIfStat>
XSI_Network::getNetIfStats(void)
{
	return (net_stats);
}

vector<struct default_route>
XSI_Network::getDefaultRoutes(void)
{
	return (default_routes);
}
